### Encoding: latin1

### Name: as.ff
### Title: Coercing ram to ff and ff to ram objects
### Aliases: as.ff as.ff.default as.ff.ff as.ram as.ram.default as.ram.ff
### Keywords: IO data

### ** Examples

   cat("create ff\n")
   myintff <- ff(1:12)
   cat("coerce (=clone) integer ff to double ff\n")
   mydoubleff <- as.ff(myintff, vmode="double")
   cat("cache (=clone) integer ff to integer ram AND close original ff\n")
   myintram <- as.ram(myintff) # filename is retained
   close(myintff)
   cat("modify ram cache and write back (=clone) to ff\n")
   myintram[1] <- -1L
   myintff <- as.ff(myintram, overwrite=TRUE)
   cat("coerce (=clone) integer ram to double ram\n")
   mydoubleram <- as.ram(myintram, vmode="double")
   cat("coerce (inplace) integer ram to double ram\n")
   myintram <- as.ram(myintram, vmode="double")
   cat("more classic: coerce (inplace) double ram to integer ram\n")
   vmode(myintram) <- "integer"
   delete(myintff)
   delete(mydoubleff)
   rm(myintff, myintram, mydoubleff, mydoubleram)



