### Encoding: latin1

### Name: as.hi
### Title: Hybrid Index, coercion to
### Aliases: as.hi as.hi.hi as.hi.call as.hi.name as.hi.( as.hi.integer
###   as.hi.double as.hi.logical as.hi.character as.hi.matrix
### Keywords: IO data

### ** Examples

  cat("integer indexing with and without rel-packing\n")
  as.hi(1:12)
  as.hi(1:12, pack=FALSE)
  cat("if index is double, the wrapper method just converts to integer\n")
  as.hi(as.double(1:12))
  cat("if index is character, the wrapper method just converts to integer\n")
  as.hi(c("a","b","c"), names=letters)
  cat("negative index must use maxindex (or vw)\n")
  as.hi(-(1:3), maxindex=12)
  cat("logical index can use maxindex\n")
  as.hi(c(FALSE, FALSE, TRUE, TRUE))
  as.hi(c(FALSE, FALSE, TRUE, TRUE), maxindex=12)

  cat("matrix index\n")
  x <- matrix(1:12, 6)
  as.hi(rbind(c(1,1), c(1,2), c(2,1)), dim=dim(x))

  cat("first ten positions within virtual window\n")
  i <- as.hi(1:10, vw=c(10, 80, 10))
  i
  cat("back-coerce relativ to virtual window\n")
  as.integer(i)
  cat("back-coerce relativ to absolute origin\n")
  as.integer(i, vw.convert=FALSE)

  cat("parsed index expressions save index RAM\n")
    as.hi(quote(1:1000000000))
## Not run: 
##D   cat("compare to RAM requirement when the index experssion is evaluated\n")
##D     as.hi(1:1000000000)
## End(Not run)

cat("example of parsable index expression\n")
  a <- seq(100, 200, 20)
  as.hi(substitute(c(1:5, 4:9, a)))
  hi(c(1,4, 100),c(5,9, 200), by=c(1,1,20))

cat("example of index expression partially expanded and accepting token\n")
  as.hi(quote(1+(1:16)))  # non-supported use of brackets '(' and mathematical operators '+' expands 1:16, parsing is aborted because length>16

cat("example of index expression completely evaluated after token has been rejected\n")
  as.hi(quote(1+(1:17)))  # non-supported use of brackets '(' and mathematical operators '+' expands 1:17, parsing is aborted because length>16



