### Encoding: latin1

### Name: dim.ff
### Title: Getting and setting dim and dimorder
### Aliases: dim.ff dim<-.ff dimorder dimorder.ff_array dimorder.default
###   dimorder<- dimorder<-.ff_array
### Keywords: IO data

### ** Examples

  x <- ff(1:12, dim=c(3,4), dimorder=c(2:1))
  y <- x
  dim(y) <- c(4,3)
  dimorder(y) <- c(1:2)
  x
  y
  x[]
  y[]
  x[,bydim=c(2,1)]
  y[,bydim=c(2,1)]

  cat("NOTE that x[] like x[,] returns a matrix (respects dimorder),\n")
  cat("while x[1:12] returns a vector IN STORAGE ORDER\n")
  cat("check the following examples twice to make sure you understand this\n")
  x[,]
  x[]
  as.vector(x[])
  x[1:12]
  delete(x)
  delete(y)
  rm(x,y)

  ## Not run: 
##D     cat("some performance comparison between different dimorders\n")
##D     n <- 100
##D     m <- 100000
##D     a <- ff(1L,dim=c(n,m))
##D     b <- ff(1L,dim=c(n,m), dimorder=2:1)
##D     system.time(lapply(1:n, function(i)sum(a[i,])))
##D     system.time(lapply(1:n, function(i)sum(b[i,])))
##D     system.time(lapply(1:n, function(i){i<-(i-1)*(m/n)+1; sum(a[,i:(i+m/n-1)])}))
##D     system.time(lapply(1:n, function(i){i<-(i-1)*(m/n)+1; sum(b[,i:(i+m/n-1)])}))
##D   
## End(Not run)



