### Encoding: latin1

### Name: levels.ff
### Title: Getting and setting factor levels
### Aliases: levels.ff levels<-.ff is.factor is.factor.default is.factor.ff
###   is.ordered is.ordered.default is.ordered.ff
### Keywords: IO data attribute

### ** Examples

  cat("--- create an ff factor including NA as last level\n")
  x <- ff("a", levels=c(letters, NA), length=99)
  cat('    we expect a warning because "A" is an unknown level\n')
  x[] <- c("a", NA,"A")
  x
  levels(x)

  cat("--- create an ff ordered factor\n")
  x <- ff(letters, levels=letters, ramclass=c("ordered","factor"), length=260)
  x
  levels(x)

  cat("    make it a non-ordered factor\n")
  virtual(x)$ramclass <- "factor"
  x

 ## Not run: 
##D   cat("--- create an unsigned quad factor\n")
##D   x <- ff(c("A","T","G","C"), levels=c("A","T","G","C"), vmode="quad", length=100)
##D   x
##D   cat("  0:3 coding usually invisible to the user\n")
##D   unclass(x[1:4])
##D   cat("    after removing levels, the 0:3 coding becomes visible to the user\n")
##D   cat("    we expect a warning here\n")
##D   levels(x) <- NULL
##D   x[1:4]
##D  
## End(Not run)

  delete(x)
  rm(x)



