### Encoding: latin1

### Name: na.count
### Title: Getting and setting 'na.count' physical attribute
### Aliases: na.count na.count.ff na.count.default na.count<- na.count<-.ff
###   na.count<-.default
### Keywords: IO data

### ** Examples

  cat("--- ff examples ---\n")
  x <- ff(1:12)
  na.count(x)
  cat("activate the 'na.count' physical attribute and set the current na.count manually\n")
  na.count(x) <- 0L
  cat("add one NA with a method that maintains na.count\n")
  swap(x, NA, 1)
  na.count(x)
  cat("remove the 'na.count' physical attribute (and stop automatic maintenance)\n")
  na.count(x) <- NULL
  cat("activate the 'na.count' physical attribute and have ff automatically calculate the current na.count\n")
  na.count(x) <- TRUE
  na.count(x)
  cat("--- ram examples ---\n")
  x <- 1:12
  na.count(x)
  x[1] <- NA
  cat("activate the 'na.count' physical attribute and have R automatically calculate the current na.count\n")
  na.count(x) <- TRUE
  na.count(x)
  cat("remove the 'na.count' physical attribute (and stop automatic maintenance)\n")
  na.count(x) <- NULL
  na.count(x)
  delete(x)
  rm(x)



